/// @cond EO_CXX_EO_IMPL

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
inline bool elm_interface_atspi_selection::child_select(int child_index_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_child_select(child_index_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
inline bool elm_interface_atspi_selection::selected_child_deselect(int child_index_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_selected_child_deselect(child_index_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
inline bool elm_interface_atspi_selection::is_child_selected(int child_index_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_is_child_selected(child_index_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
inline bool elm_interface_atspi_selection::all_children_select() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_all_children_select());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
inline bool elm_interface_atspi_selection::clear() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_clear());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
inline bool elm_interface_atspi_selection::child_deselect(int child_index_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_child_deselect(child_index_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
inline int elm_interface_atspi_selection::selected_children_count_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_selected_children_count_get());
   return _tmp_ret;
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
inline ::efl::eo::concrete elm_interface_atspi_selection::selected_child_get(int selected_child_index_) const
{
   Eo * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_selected_child_get(selected_child_index_));
   return ::efl::eolian::to_cxx<::efl::eo::concrete>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
inline bool eo_cxx::elm_interface_atspi_selection::child_select(int child_index_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_child_select(child_index_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
inline bool eo_cxx::elm_interface_atspi_selection::selected_child_deselect(int child_index_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_selected_child_deselect(child_index_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
inline bool eo_cxx::elm_interface_atspi_selection::is_child_selected(int child_index_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_is_child_selected(child_index_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
inline bool eo_cxx::elm_interface_atspi_selection::all_children_select() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_all_children_select());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
inline bool eo_cxx::elm_interface_atspi_selection::clear() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_clear());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
inline bool eo_cxx::elm_interface_atspi_selection::child_deselect(int child_index_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_child_deselect(child_index_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
inline int eo_cxx::elm_interface_atspi_selection::selected_children_count_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_selected_children_count_get());
   return _tmp_ret;
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
inline ::efl::eo::concrete eo_cxx::elm_interface_atspi_selection::selected_child_get(int selected_child_index_) const
{
   Eo * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_selected_child_get(selected_child_index_));
   return ::efl::eolian::to_cxx<::efl::eo::concrete>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

inline ::eo_cxx::elm_interface_atspi_selection::operator ::elm_interface_atspi_selection() const
{
   return *static_cast<::elm_interface_atspi_selection const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm_interface_atspi_selection::operator ::elm_interface_atspi_selection&()
{
   return *static_cast<::elm_interface_atspi_selection*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm_interface_atspi_selection::operator ::elm_interface_atspi_selection const&() const
{
   return *static_cast<::elm_interface_atspi_selection const*>(static_cast<void const*>(this));
}

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
template <typename T>
bool _elm_interface_atspi_selection_child_select_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int child_index_)
{
   try
      {
         return static_cast<T*>(self->this_)->child_select(child_index_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
template <typename T>
bool _elm_interface_atspi_selection_selected_child_deselect_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int child_index_)
{
   try
      {
         return static_cast<T*>(self->this_)->selected_child_deselect(child_index_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
template <typename T>
bool _elm_interface_atspi_selection_is_child_selected_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int child_index_)
{
   try
      {
         return static_cast<T*>(self->this_)->is_child_selected(child_index_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
template <typename T>
bool _elm_interface_atspi_selection_all_children_select_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->all_children_select();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
template <typename T>
bool _elm_interface_atspi_selection_clear_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->clear();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
template <typename T>
bool _elm_interface_atspi_selection_child_deselect_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int child_index_)
{
   try
      {
         return static_cast<T*>(self->this_)->child_deselect(child_index_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
template <typename T>
int _elm_interface_atspi_selection_selected_children_count_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->selected_children_count_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         int _tmp_ret{};
         return _tmp_ret;
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
template <typename T>
::efl::eo::concrete _elm_interface_atspi_selection_selected_child_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int selected_child_index_)
{
   try
      {
         return static_cast<T*>(self->this_)->selected_child_get(selected_child_index_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eo * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eo::concrete>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_atspi_selection >
{
   template <typename T>
   struct type
   {
#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
      virtual bool child_select(int child_index_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_selection_child_select(child_index_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
      virtual bool selected_child_deselect(int child_index_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_selection_selected_child_deselect(child_index_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
      virtual bool is_child_selected(int child_index_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_selection_is_child_selected(child_index_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
      virtual bool all_children_select()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_selection_all_children_select());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
      virtual bool clear()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_selection_clear());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
      virtual bool child_deselect(int child_index_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_selection_child_deselect(child_index_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
      virtual int selected_children_count_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_selection_selected_children_count_get());
            return _tmp_ret;
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
      virtual ::efl::eo::concrete selected_child_get(int selected_child_index_)
      {
         Eo * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_selection_selected_child_get(selected_child_index_));
            return ::efl::eolian::to_cxx<::efl::eo::concrete>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

   };
};


template<>
struct operation_description_class_size< ::elm_interface_atspi_selection >
{
   static constexpr int value = 
#if defined(ELM_INTERFACE_ATSPI_SELECTION_PROTECTED) && defined(ELM_INTERFACE_ATSPI_SELECTION_BETA)
      8
#elif defined(ELM_INTERFACE_ATSPI_SELECTION_PROTECTED)
      8
#elif defined(ELM_INTERFACE_ATSPI_SELECTION_BETA)
      0
#else
      0
#endif
;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm_interface_atspi_selection>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_selection_child_select_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_selection_child_select);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_selection_selected_child_deselect_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_selection_selected_child_deselect);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_selection_is_child_selected_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_selection_is_child_selected);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_selection_all_children_select_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_selection_all_children_select);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_selection_clear_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_selection_clear);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_selection_child_deselect_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_selection_child_deselect);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_selection_selected_children_count_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_selection_selected_children_count_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_selection_selected_child_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_selection_selected_child_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm_interface_atspi_selection>)
{
   return (ELM_INTERFACE_ATSPI_SELECTION_INTERFACE);
}

} } }

/// @endcond

